<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 */
class m120501_115457_custom_user_fields extends CDbMigration
{
    public function safeUp()
    {
        try{
            $this->renameColumn('{{profiles}}', 'buisness_zip', 'business_zip');
            $this->renameColumn('{{profiles}}', 'buisness_country', 'business_country');
            $this->renameColumn('{{profiles}}', 'buisness_phone_number', 'business_phone_number');
            $this->renameColumn('{{profiles}}', 'buisness_mobile_phone_number', 'business_mobile_phone_number');
            $this->renameColumn('{{profiles}}', 'buisness_city', 'business_city');

            $this->update("{{profiles_fields}}", array("varname" => "business_zip"), "varname='buisness_zip'");
            $this->update("{{profiles_fields}}", array("varname" => "business_country"), "varname='buisness_country'");
            $this->update("{{profiles_fields}}", array("varname" => "business_phone_number"), "varname='buisness_phone_number'");
            $this->update("{{profiles_fields}}", array("varname" => "business_mobile_phone_number"), "varname='buisness_mobile_phone_number'");
            $this->update("{{profiles_fields}}", array("varname" => "business_city"), "varname='buisness_city'");
        }catch (Exception $e){}
    }

    public function safeDown()
    {
        $this->renameColumn("{{profiles}}", "business_zip", "buisness_zip");
        $this->renameColumn("{{profiles}}", "business_country", "buisness_country");
        $this->renameColumn("{{profiles}}", "business_phone_number", "buisness_phone_number");
        $this->renameColumn("{{profiles}}", "business_mobile_phone_number", "buisness_mobile_phone_number");
        $this->renameColumn("{{profiles}}", "business_city", "buisness_city");

        $this->update("{{profiles_fields}}", array("varname" => "buisness_zip"), "varname='business_zip'");
        $this->update("{{profiles_fields}}", array("varname" => "buisness_country"), "varname='business_country'");
        $this->update("{{profiles_fields}}", array("varname" => "buisness_phone_number"), "varname='business_phone_number'");
        $this->update("{{profiles_fields}}", array("varname" => "buisness_mobile_phone_number"), "varname='business_mobile_phone_number'");
        $this->update("{{profiles_fields}}", array("varname" => "buisness_city"), "varname='business_city'");

        return true;
    }

    /*
     // Use safeUp/safeDown to do migration with transaction
     public function safeUp()
     {
     }

     public function safeDown()
     {
     }
     */
}