(function($) {
	
	DocumentFragment.prototype.append = function() {
		for(var i=0, l=arguments.length; i<l; i++) {
			this.appendChild( $(arguments[i]).get(0) )
		}
		return this;
	};
	
	$.loadJSFileStack = [];
	/*$.loadJSFile = function(url, onloadCallback, ignoreStack)
	{
		if($.loadJSFileStack.indexOf( url ) == -1 || ignoreStack == true) {
			$.loadJSFileStack.push( url );
			$( "<script>", {type: "text/javascript", src: url} )
				.load( onloadCallback )
				.appendTo( "head" );
		} else {
			if(typeof onloadCallback == "function") {
				onloadCallback.apply();
			}
		}
	}*/
	/**
	 * Load JavaScript file
	 * @function
	 * @param {string} url url path to the file
	 * @param {function} onloadCallback fire function after file is loaded
	 * @param {boolean} ignoreStack ignore unqiue check
	 */
	$.loadJSFile = function(url, onloadCallback, ignoreStack)
	{
		if($.loadJSFileStack.indexOf( url ) == -1 || ignoreStack == true) {
			$.loadJSFileStack.push( url );
			$.getScript( url, onloadCallback );
			return true;
		} else {
			if(typeof onloadCallback == "function") {
				onloadCallback.apply();
			}
			return false;
		}
	}
	
	$.loadCSSFileStack = [];
	$.loadCSSFile = function(url, onloadCallback, ignoreStack)
	{
		if($.loadCSSFileStack.indexOf( url ) == -1 || ignoreStack == true) {
			$.loadCSSFileStack.push( url );
			$( "<link/>" , {rel: "stylesheet", type: "text/css", href: url})
				.load( onloadCallback )
				.appendTo( "head" );
		} else {
			if(typeof onloadCallback == "function") {
				onloadCallback.apply();
			}
		}
	}
	
	$.loadAsset = function(urls, onloadCallback, ignoreStack)
	{
		if(typeof urls === "string") {
			urls = [urls];
		}
		var url = $.fg.Config.basePath + "/" + urls.shift();
		var callback;
		if(urls.length > 0) {
			callback = function()
			{
				$.loadAsset( urls, onloadCallback, ignoreStack );
			}
		} else {
			callback = onloadCallback;
		}
		switch(url.split( "." ).pop())
		{
			case "js":
				$.loadJSFile( url, callback, ignoreStack );
				break;
			case "css":
				$.loadCSSFile( url, callback, ignoreStack );
				break;
		}
	}
	
	$.include = function(url, onloadCallback)
	{
		switch(url.split( "." ).pop())
		{
			case "js":
				$.ajax( {
				  url: url,
				  dataType: "script",
				  success: onloadCallback,
				  async: false
				} );
				break;
			case "css":
				$.loadCSSFile( url, onloadCallback );
				break;
		}
	}
	
	// Several of the methods in this plugin use code adapated from Prototype
	//  Prototype JavaScript framework, version 1.6.0.1
	//  (c) 2005-2007 Sam Stephenson
	var regs = {
		undHash: /_|-/,
		colons: /::/,
		words: /([A-Z]+)([A-Z][a-z])/g,
		lowUp: /([a-z\d])([A-Z])/g,
		dash: /([a-z\d])([A-Z])/g,
		replacer: /\{([^\}]+)\}/g,
		dot: /\./
	},
		getNext = function(current, nextPart, add){
			return current[nextPart] || ( add && (current[nextPart] = {}) );
		},
		isContainer = function(current){
			var type = typeof current;
			return type && (  type == 'function' || type == 'object' );
		},
		getObject = function( objectName, roots, add ) {
			
			var parts = objectName ? objectName.split(regs.dot) : [],
				length =  parts.length,
				currents = $.isArray(roots) ? roots : [roots || window],
				current,
				ret, 
				i,
				c = 0,
				type;
			
			if(length == 0){
				return currents[0];
			}
			while(current = currents[c++]){
				for (i =0; i < length - 1 && isContainer(current); i++ ) {
					current = getNext(current, parts[i], add);
				}
				if( isContainer(current) ) {
					
					ret = getNext(current, parts[i], add); 
					
					if( ret !== undefined ) {
						
						if ( add === false ) {
							delete current[parts[i]];
						}
						return ret;
						
					}
					
				}
			}
		};
	
	$.String = $.extend( $.String || {} , {
			/**
			 * @function
			 * Gets an object from a string.
			 * @param {String} name the name of the object to look for
			 * @param {Array} [roots] an array of root objects to look for the name
			 * @param {Boolean} [add] true to add missing objects to 
			 *  the path. false to remove found properties. undefined to 
			 *  not modify the root object
			 */
			getObject : getObject,
			/**
			 * Capitalizes a string
			 * @param {String} s the string.
			 * @return {String} a string with the first character capitalized.
			 */
			capitalize: function( s, cache ) {
				return s.charAt(0).toUpperCase() + s.substr(1);
			},
			/**
			 * Capitalizes a string from something undercored. Examples:
			 * @codestart
			 * jQuery.String.camelize("one_two") //-> "oneTwo"
			 * "three-four".camelize() //-> threeFour
			 * @codeend
			 * @param {String} s
			 * @return {String} a the camelized string
			 */
			camelize: function( s ) {
				s = str.classize(s);
				return s.charAt(0).toLowerCase() + s.substr(1);
			},
			/**
			 * Like camelize, but the first part is also capitalized
			 * @param {String} s
			 * @return {String} the classized string
			 */
			classize: function( s , join) {
				var parts = s.split(regs.undHash),
					i = 0;
				for (; i < parts.length; i++ ) {
					parts[i] = str.capitalize(parts[i]);
				}

				return parts.join(join || '');
			},
			/**
			 * Like [jQuery.String.classize|classize], but a space separates each 'word'
			 * @codestart
			 * jQuery.String.niceName("one_two") //-> "One Two"
			 * @codeend
			 * @param {String} s
			 * @return {String} the niceName
			 */
			niceName: function( s ) {
				str.classize(parts[i],' ');
			},

			/**
			 * Underscores a string.
			 * @codestart
			 * jQuery.String.underscore("OneTwo") //-> "one_two"
			 * @codeend
			 * @param {String} s
			 * @return {String} the underscored string
			 */
			underscore: function( s ) {
				return s.replace(regs.colons, '/').replace(regs.words, '$1_$2').replace(regs.lowUp, '$1_$2').replace(regs.dash, '_').toLowerCase();
			},
			/**
			 * Returns a string with {param} replaced values from data.
			 * 
			 *     $.String.sub("foo {bar}",{bar: "far"})
			 *     //-> "foo far"
			 *     
			 * @param {String} s The string to replace
			 * @param {Object} data The data to be used to look for properties.  If it's an array, multiple
			 * objects can be used.
			 * @param {Boolean} [remove] if a match is found, remove the property from the object
			 */
			sub: function( s, data, remove ) {
				var obs = [];
				obs.push(s.replace(regs.replacer, function( whole, inside ) {
					//convert inside to type
					var ob = getObject(inside, data, typeof remove == 'boolean' ? !remove : remove),
						type = typeof ob;
					if((type === 'object' || type === 'function') && type !== null){
						obs.push(ob);
						return "";
					}else{
						return ""+ob;
					}
				}));
				return obs.length <= 1 ? obs[0] : obs;
			}
		});
	
})(jQuery);