<?php

/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 * HistoryModule
 * This module allows user to remember pages he was visited 
 *
 * Interaction with module performs with one widget and one function
 * Widget:
 * - LastVisitedPages - displays last N visited pages
 *
 * HistoryModule::save() function save specified page to user history
 * HistoryModule::flushHistory() flush current user history
 *
**/
class PiwikModule extends CWebModule
{

    /**
     * Piwik-Token to identify 
     *
     * @var string
     **/
    public $token;

    /**
     * url to the Piwik-Service
     *
     * @var string
     **/
    public $piwikServerURL;

    /**
     * commaseperated list of sites OR "all"
     *
     * @var string
     **/
    public $sites = "all";

    /**
     * Amount of displaying items
     *
     * @var string
     **/
    public $count = 10;

    /**
     * How long history will be storing in cache
     *
     * @var string
     **/
    public $cacheTime = 3600;

    public function init()
    {
        parent::init();        
    }

    /**
     * Translates a message to the specified language.
     *
     * @param string $str    message
     * @param array  $params params
     * @param string $dic    dictionary
     *
     * @return string
     */
    public static function t($str = '', $params = array(), $dic = 'core')
    {
        return Yii::t("PiwikModule." . $dic, $str, $params);
    }
}
