<?php

class UWjuidate
{

    /**
     * @var array
     */
    public $params = array(
        'ui-theme' => 'base',
//        'language' => 'en',
        'defaultDate' => '',
        'maxDate' => '',
        'minDate' => '',
        'yearRange' => '',
        'changeMonth' => true,
        'changeYear' => true
    );

    /**
     * Initialization
     * @return array
     */
    public function init()
    {
        return array(
            'name' => __CLASS__,
            'label' => UserModule::t('jQueryUI datepicker'),
            'fieldType' => array('DATE', 'VARCHAR'),
            'params' => $this->params,
            'paramsLabels' => array(
                'dateFormat' => UserModule::t('Date format'),
            ),
        );
    }

    /**
     * @param $value
     * @param $model
     * @param $field_varname
     * @return string
     */
    public function setAttributes($value, $model, $field_varname)
    {
        if ($value == '0000-00-00') $value = '';
        return $value;
    }

    /**
     * @param $model - profile model
     * @param $field - profile fields model item
     * @return string
     */
    public function viewAttribute($model, $field)
    {
        return $model->getAttribute($field->varname);
    }

    /**
     * @param $model - profile model
     * @param $field - profile fields model item
     * @param $params - htmlOptions
     * @return string
     */
    public function editAttribute($model, $field, $htmlOptions = array())
    {
        if (!isset($htmlOptions['size'])) $htmlOptions['size'] = 60;
        if (!isset($htmlOptions['maxlength'])) $htmlOptions['maxlength'] = (($field->field_size) ? $field->field_size : 10);
        if (!isset($htmlOptions['id'])) $htmlOptions['id'] = get_class($model) . '_' . $field->varname;

        $id = $htmlOptions['id'];
        $options = $this->params;
        $options['dateFormat'] = LocaleHelper::yiiFormatToJq(Yii::app()->locale->getDateFormat());
        $options['returnDateFormat'] = LocaleHelper::yiiFormatToJq('yyyy-mm-dd');
        $options['language'] = LocaleHelper::yiiLocaleToJq(Yii::app()->language);
        if (!empty($model->{$field->varname})) {
            $timestamp = strtotime($model->{$field->varname});
            if ($timestamp >= 0 && $timestamp !== false) {
                $options['date'] = $timestamp;
            }
        }
        if ($widgetParams = CJSON::decode($field->widgetparams)) {
            $options = array_merge($options, $widgetParams);
        }
        $options = CJavaScript::encode($options);

        $cs = Yii::app()->getClientScript();
        $baseUrl = $cs->getCoreScriptUrl();
        $cs->registerCssFile($baseUrl . '/jui/css/' . $this->params['ui-theme'] . '/jquery-ui.css', '', null, false);
        $cs->registerScriptFile($baseUrl . '/jui/js/jquery-ui.min.js');

        $cs->registerScriptFile(Yii::app()->getModule('user')->getAssetsUrl() . '/js/jquery.datepickerL10.js');

        $language = LocaleHelper::yiiLocaleToJq(Yii::app()->language);
        if ($language != 'en') {
            $js = "jQuery('#{$id}').datepickerL10(jQuery.extend({showMonthAfterYear:false}, jQuery.datepicker.regional['{$language}'], $options));";
            $cs->registerScriptFile($baseUrl . '/jui/js/jquery-ui-i18n.min.js');
        } else $js = "jQuery('#{$id}').datepickerL10($options);";

        $cs->registerScript('ProfileFieldController' . '#' . $id, $js);

        return CHtml::activeTextField($model, $field->varname, $htmlOptions);
    }

}