<?php
/**
 *
 */
class Account extends CActiveRecord
{
    /**
     * Returns the static model of the specified AR class.
     * @return CActiveRecord the static model class
     */
    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    /**
     * @return string the associated database table name
     */
    public function tableName()
    {
        return Yii::app()->getModule('user')->tableAccounts;
    }

    public function rules()
    {
        return array(
            array('service, service_id', 'required'),
            array('user_id', 'numerical', 'integerOnly' => true),
            array('service, service_id', 'length', 'max' => 255),
            array('data', 'safe')
        );
    }

    public function relations()
    {
        return array(
            'user' => array(self::HAS_ONE, 'User', array('id' => 'user_id'))
        );
    }

    public function afterFind()
    {
        $this->data = (array)unserialize($this->data);
        return parent::afterFind();
    }

    public function beforeSave()
    {
        $this->data = serialize((array)$this->data);
        return parent::beforeSave();
    }

    public static function create($service)
    {
        $account = new Account();
        $account->attributes = array(
            'service' => $service->serviceName,
            'service_id' => $service->id,
        );
        $account->save();

        return $account;
    }
}
