<?php
/**
 * Apalines module has separate config because its settings should be the same in the console and frontend configurations so
 * to achieve this goal current configuration file is included in both configurations (client_main/client_console)
 *
 * @author Andrew Voloshin <andrew.voloshin@oberig.com>
 *
 */
Yii::setPathOfAlias('unit', dirname(__FILE__) . DIRECTORY_SEPARATOR . '..' . DIRECTORY_SEPARATOR
                    . '..' . DIRECTORY_SEPARATOR . 'tests' . DIRECTORY_SEPARATOR . 'unit');
return array(

    'class' => 'site.common.modules.apalines.APALinesModule',
    'customer_number' => 'CB86E6F1-1847-4BD9-8FA7-E5606B97BCE8',
    'video_url' => 'http://videoservice.apa.at/Player/UniversalPlayer.aspx',
    'cacheTime' => 60,
    'total_max_age_of_news' => 24*30*12*5, //about 5 years
    'total_max_count_of_news' => 50,
    //Sizes
    'DefaultSize'=>'640x480',
    'VideoSize'=>'640x480',
    'OriginalSize'=>'640x480',
    'ThumbnailSize'=>'320x240',
    'HiresSize'=>'128x128',

    'channels' =>
    array(
        //The following channel is necessary for unit test and must be specified here because it is used for checking whether the inotify works
        'unit_test' => array(
            'delivery_path' => 'unit.apalines.content.work',
        ),
        'test1' => array(
            'max_age_of_news' => 24*30*12*5,
            'max_count_of_news' => 30,
            'delivery_path' => 'apalines.content.News1',
        ),
        'test2' => array(
            'max_age_of_news' => 24*30*12,
            'max_count_of_news' => 30,
            'delivery_path' => 'apalines.content.News2',
        ),
        'test3' => array(
            'max_age_of_news' => 24*30*12,
            'max_count_of_news' => 30,
            'delivery_path' => 'apalines.content.News3',
        ),
        'test4' => array(
            'max_age_of_news' => 24*30*12,
            'max_count_of_news' => 30,
            'delivery_path' => 'apalines.content.News4',
        ),
        'test5' => array(
            'max_age_of_news' => 24*30*12,
            'max_count_of_news' => 30,
            'delivery_path' => 'apalines.content.News5',
        ),

    ),
);